;;; Calling a scheme function from C using a closure and C_callback
;;; rather than define-external

;; May also be advisable to call C_callback_adjust_stack_limits (?)

(define (foo x)
  (print "In foo");
  (+ 1 x))

(define c:call-procedure
  (foreign-safe-lambda* scheme-object ((scheme-object proc) (scheme-object x)) #<<EOF
    C_word ret;
    printf("Calling procedure...\n");
    C_save(x);   /* If x is an actual int, you must C_fix it */
    ret = C_callback(proc, 1);
    printf("Procedure complete\n");
    return(ret);
EOF
))


;; (c:call-procedure foo 3)
;; Calling procedure...
;; In foo
;; Procedure complete
;; 4
