 (use objc)
 (define-objc-class MyPoint NSObject ((DBL x)
                                      (DBL y)
                                      (slot: closure))
   (define-method ID init
     (print "MyPoint init")
     (@ super init))
   (- DBL getX @x)
   (- DBL getY @y)
   (- ID description
      (sprintf "<MyPoint: (~a, ~a)>" @x @y))
   (- VOID ((move-by-x: DBL a) (y: DBL b))
     (set! @x (+ a @x))
     (ivar-set! self y (+ b (ivar-ref self y))))  ;; more wordy
   (- ID ((init-with-x: DBL a) (y: DBL b))
      (let ((p (@ self init)))
        (@ p move-by-x: a y: b)
        (set! @closure (lambda (msg)
                         (cond ((eq? msg 'initial-x) 
                                (print "MyPoint: initial x was " a))
                               ((eq? msg 'initial-y) 
                                (print "MyPoint: initial y was " b)))))
        (set-finalizer! @closure (lambda (x) (print "finalizing closure")))
        p)))

 (define p (@ (@ MyPoint alloc) init-with-x: 3.4 y: 4.5))
 (@ p move-by-x: 2 y: 3)
 ((ivar-ref p closure) 'initial-x)

